﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Test_WebEventmanager : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void uxSubmit_Click(object sender, EventArgs e)
    {
        // Here we read the values that were entered into the form.
        long calendarId = Convert.ToInt64(uxWebCalendarID.Text);
        String st = uxStartDate.Text + " " + uxStartTime.SelectedItem.Text + ":00:00 " + uxStartPeriod.SelectedItem.Text;
        String et = uxEndDate.Text + " " + uxEndTime.SelectedItem.Text + ":00:00 " + uxEndPeriod.SelectedItem.Text;
        DateTime startdatetime = DateTime.Parse(st);
        DateTime endDatetime = DateTime.Parse(et);
        
        Ektron.Cms.Framework.Calendar.WebEventManager webEventManager = new Ektron.Cms.Framework.Calendar.WebEventManager();

        // Here we grab the events in the range specified with a buffer of +/- 15 Days to account for multi day events.
        Ektron.Cms.Common.WebEventCriteria criteria = new Ektron.Cms.Common.WebEventCriteria();
        criteria.AddFilter(Ektron.Cms.Common.EventProperty.CalendarId, Ektron.Cms.Common.CriteriaFilterOperator.EqualTo, calendarId);
        criteria.AddFilter(Ektron.Cms.Common.EventProperty.StartUtc, Ektron.Cms.Common.CriteriaFilterOperator.GreaterThanOrEqualTo, startdatetime.AddDays(-15).ToUniversalTime());
        criteria.AddFilter(Ektron.Cms.Common.EventProperty.EndUtc, Ektron.Cms.Common.CriteriaFilterOperator.LessThanOrEqualTo, endDatetime.AddDays(15).AddMinutes(-1).ToUniversalTime());

        var recurEventsData = webEventManager.GetEventOccurrenceList(criteria);
        
        // Remove The Extra Events Taking the Multiple Day Events into consideration
        recurEventsData.RemoveAll(x => ((x.EventStart < startdatetime && x.EventEnd < startdatetime)) || (x.EventStart > endDatetime && x.EventEnd > endDatetime));

        //Display the Web Event Details
        uxEventlistView.Visible = true;
        uxEventlistView.DataSource = recurEventsData;
        uxEventlistView.DataBind();
    }
}